open import lib.Prelude 
open List using (_++_) 
open List.In using (_-_)
-- open List.InLists
-- open List.Subsets

open import foc.focbind.univ.examples.DefinedAtoms 
open import foc.focbind.univ.Types 
open import foc.focbind.univ.Semantics 
open import foc.focbind.univ.Structural
open import foc.focbind.univ.examples.Sig

module foc.focbind.univ.examples.Reduce where
  open Sig
  open Semantics(theSig)
  open Structural(theSig)

  red : (∀⇛  exp  ⊃  exp ⊕ 1⁺)
  red Ψ (▹ x) = Inr <>
  red Ψ (app · (lam · e , e2)) = Inl (subst exp Ψ e e2)
  red Ψ (app · (e1 , e2)) with red Ψ e1 
  ...                        | Inl e1' = Inl (app · (e1' , e2))
  ...                        | Inr _   = red Ψ e2
  red Ψ (lam · e) with red (expC :: Ψ) e
  ...                | Inl e' = Inl (lam · e')
  ...                | Inr p = Inr p
