
open import lib.SumsProds
open import lib.Id

module lib.String where

module String where

  module StringOP where
    postulate String : Set
    {-# BUILTIN STRING  String #-}

  open StringOP public

  private
    primitive
--    primStringToList   : String -> List Char
--     primStringFromList : List Char -> String
       primStringAppend   : String -> String -> String
       primStringEquality : String -> String -> Sums.Bool

  equal : String -> String -> Sums.Bool
  equal = primStringEquality

  postulate 
    same-eq : {s : String} -> Id.Id (equal s s) Sums.True